﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WG_ValueBasedAppearanceSelectedRows
{
    class CustomCondition : ICondition
    {
        private ConditionOperator condition;

        public CustomCondition(ConditionOperator condition)
        {
            this.condition = condition;
        }

        public bool Matches(object value, IConditionContextProvider contextProvider)
        {
            
            if (contextProvider is CellContextProvider)
            {
                UltraGridCell cell = contextProvider.Context as UltraGridCell;

                if (condition == ConditionOperator.LessThanOrEqualTo)
                {
                    if ((double)cell.Value <= (double)value)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    if ((double)cell.Value >= (double)value)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
            }
            else
            {
                return false;//throw new ArgumentException();
            }
        }

        public event EventHandler PropertyChanged;

        public object Clone()
        {
            throw new NotImplementedException();
        }
    }

    class CellContextProvider : IConditionContextProvider
    {
        private UltraGridCell cell;
        public CellContextProvider(UltraGridCell cell)
        {
            this.cell = cell;
        }
        public object Context
        {
            get { return cell; }
        }
    }
}
