﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_ValueBasedAppearanceSelectedRows
{
    public partial class Form1 : Form
    {
        CustomCondition lowCond = null;
        CustomCondition highCond = null;
        Infragistics.Win.Appearance lowApp = null;
        Infragistics.Win.Appearance highApp = null;
        Infragistics.Win.Appearance defaultSelectedApp = null;
        Infragistics.Win.Appearance defaultNormalApp = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeApearances();
            InitializeConditions();

            DataSet ds = new DataSet();
            setUpDataSchema(ds);
            getData(ds);
            ultraGrid1.DataSource = ds;
        }

        private void InitializeApearances()
        {
            lowApp = new Infragistics.Win.Appearance();
            lowApp.ForeColor = Color.Green;
            highApp = new Infragistics.Win.Appearance();
            highApp.ForeColor = Color.Red;
            defaultSelectedApp = new Infragistics.Win.Appearance();
            defaultSelectedApp.ForeColor = Color.White;
            defaultNormalApp = new Infragistics.Win.Appearance();
            defaultNormalApp.ForeColor = Color.Black;
        }

        private void InitializeConditions()
        {
            lowCond = new CustomCondition(ConditionOperator.LessThanOrEqualTo);
            highCond = new CustomCondition(ConditionOperator.GreaterThanOrEqualTo);
        }

        private void setUpDataSchema(DataSet ds)
        {
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));
        }

        private void getData(DataSet ds)
        {

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;

            e.Layout.Override.SelectTypeCell = Infragistics.Win.UltraWinGrid.SelectType.None;
            e.Layout.Override.SelectTypeCol = Infragistics.Win.UltraWinGrid.SelectType.None;
            e.Layout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single;

            ConditionValueAppearance valApp = new ConditionValueAppearance();

            e.Layout.Bands[0].Override.ActiveAppearancesEnabled = DefaultableBoolean.False;


        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            setSelectedAppearance(e.Row);
        }

        private void setSelectedAppearance(UltraGridRow row)
        {
            UltraGridCell cell = row.Cells["Price"];
            if (lowCond.Matches(20d, new CellContextProvider(cell)))
            {
                row.Cells["Price"].SelectedAppearance = lowApp;
                //use diffrent normal appearance if you need to
                row.Cells["Price"].Appearance = lowApp;
            }
            else
            {
                if (highCond.Matches(80d, new CellContextProvider(cell)))
                {
                    row.Cells["Price"].SelectedAppearance = highApp;
                    //use diffrent normal appearance if you need to
                    row.Cells["Price"].Appearance = highApp;
                }
                else
                {
                    row.Cells["Price"].SelectedAppearance = defaultSelectedApp;
                    row.Cells["Price"].Appearance = defaultNormalApp;
                }
            }
        }
    }
}
